package controller;

import champ2010client.SensorModel;
/**
 * Trieda urcena pre stabilizaciu auta, ABS a ASR.
 * 
 * @author Maros Bednar
 */
public class ESP {
	
	final static float wheelRadius[]={(float) 0.3179,(float) 0.3179,(float) 0.3276,(float) 0.3276};
	final static float slipAllow=(float) 0.1; // = 10%, sluzi ako parameter kedy vzniknu neziaduce ucinky
	static double actionBrakeAktual = (double)0;
	static double actionBrakeTickBack = (double)0;
	static double actionAccelAktual = (double)0;
	static double actionAccelTickBack = (double)0;
	
	/**
	 * metoda ABS. Koreckia stlacenia brzdoveho pedalu
	 * 
	 * @param sensors senzormodel
	 * @param double velkostBrzdy
	 * @return double velkostBrzdy - upravena aby nenastal lock
	 */
	public static double filterABS(SensorModel sensors,double brake){
		double speed = (double) (sensors.getSpeed() / 3.6);
		double slip = 0.0;
	    for (int i = 0; i < 4; i++)
	    {
	        slip += sensors.getWheelSpinVelocity()[i] * wheelRadius[i];
	    }
	    double speedWheelAverage = (double) slip/4.0f;
	    double alfa = 1 - (speedWheelAverage/speed);
	    if (alfa > slipAllow)
	    {
	    
	    	//NEGATIVNE POSOBENIE 
	    	brake = actionBrakeTickBack ;
	    	actionBrakeAktual = brake;
	    	actionBrakeTickBack -= 0.1;    	
	    }
	    else{
	    	//NEPESMYKUJE, v ramci 20%
	    	actionBrakeTickBack = brake;
	    	brake  = brake +(double)0.1;
	    	if(brake > 1){
	    		actionBrakeAktual = 1;
	    		brake = 1;
	    	}
	    	else{
	    		actionBrakeAktual = brake;
	    	}
	    	
	    }
	
	   	return brake;
	}
	/**
	 * metoda ASR. Koreckia stlacenia plynoveho pedalu
	 * 
	 * @param sensors senzormodel
	 * @param double velkostPlynu
	 * @return double velkostPlynu - upravena aby nenastalo preklzovanie
	 */
	public static double filterASR(SensorModel sensors,double accelerate){
		double speed = (double) (sensors.getSpeed() / 3.6);
		double slipR = 0.0;
		slipR = (sensors.getWheelSpinVelocity()[2]+
				sensors.getWheelSpinVelocity()[3])
				* wheelRadius[2];
		
		double speedWheelAverage = slipR/2.0;//preklzovanie zadnej napravy
		double alfa = (speedWheelAverage/speed)-1;
	    
		if (alfa > slipAllow)
		{
			//NEGATIVNE POSOBENIE 
			accelerate = actionAccelTickBack ;
	    	actionAccelAktual = accelerate;
	    	actionAccelTickBack -= 0.1;    	
	    }
	    else{
	    	//NEPESMYKUJE
	    	actionAccelTickBack = accelerate;
	    	accelerate  = accelerate +(double)0.1;
	    	if(accelerate > 1){
	    		actionAccelAktual = 1;
	    		accelerate = 1;
	    	}
	    	else{
	    		actionAccelAktual = accelerate;
	    	}
	    	
	    }
		return accelerate;
	}
}
